## ros-foxy-orocos-kdl 3.3.5

=== src/CMakeLists.txt ===
FILE( GLOB_RECURSE KDL_SRCS [^.]*.cpp [^.]*.cxx)
FILE( GLOB KDL_HPPS [^.]*.hpp [^.]*.inl)

FILE( GLOB UTIL_HPPS utilities/[^.]*.h utilities/[^.]*.hpp)

INCLUDE(CheckCXXSourceCompiles)
SET(CMAKE_REQUIRED_FLAGS)
CHECK_CXX_SOURCE_COMPILES("
    #include <string>
    #include <map>
    #include <vector.hpp>

    class TreeElement;
    typedef std::map<std::string, TreeElement> SegmentMap;

    class TreeElement
    {
        TreeElement(const std::string& name): number(0) {}

    public:
        int number;
        SegmentMap::const_iterator parent;
        std::vector<SegmentMap::const_iterator> children;

        static TreeElement Root(std::string& name)
        {
            return TreeElement(name);
        }
    };

    int main()
    {
        return 0;
    }
    "
    HAVE_STL_CONTAINER_INCOMPLETE_TYPES)

if(HAVE_STL_CONTAINER_INCOMPLETE_TYPES)
    SET(KDL_USE_NEW_TREE_INTERFACE_DEFAULT Off)
ELSE(HAVE_STL_CONTAINER_INCOMPLETE_TYPES)
    SET(KDL_USE_NEW_TREE_INTERFACE_DEFAULT On)
ENDIF(HAVE_STL_CONTAINER_INCOMPLETE_TYPES)

SET(KDL_USE_NEW_TREE_INTERFACE ${KDL_USE_NEW_TREE_INTERFACE_DEFAULT} CACHE BOOL "Use the new KDL Tree interface")

#Sanity check, inform the user
IF(NOT HAVE_STL_CONTAINER_INCOMPLETE_TYPES AND NOT KDL_USE_NEW_TREE_INTERFACE)
    MESSAGE(WARNING "You have chosen to use the current Tree Interface, but your platform doesn't support containers of "
        "incomplete types, this configuration is likely invalid")
ENDIF()

#In Windows (Visual Studio) it is necessary to specify the postfix
#of the debug library name and no symbols are exported by kdl, 
#so it is necessary to compile it as a static library
IF(MSVC)
    SET(CMAKE_DEBUG_POSTFIX "d")
    SET(LIB_TYPE STATIC)
ELSE(MSVC)
    SET(LIB_TYPE SHARED)
ENDIF(MSVC)

CONFIGURE_FILE(config.h.in config.h @ONLY)

#### Settings for rpath
IF(${CMAKE_MINIMUM_REQUIRED_VERSION} VERSION_GREATER "2.8.12")
    MESSAGE(AUTHOR_WARNING "CMAKE_MINIMUM_REQUIRED_VERSION is now ${CMAKE_MINIMUM_REQUIRED_VERSION}. This check can be removed.")
ENDIF()
IF(NOT (CMAKE_VERSION VERSION_LESS 2.8.12))
    IF(NOT MSVC)
        #add the option to disable RPATH
        OPTION(OROCOSKDL_ENABLE_RPATH "Enable RPATH during installation" TRUE)
        MARK_AS_ADVANCED(OROCOSKDL_ENABLE_RPATH)
    ENDIF(NOT MSVC)

    IF(OROCOSKDL_ENABLE_RPATH)
        #Configure RPATH
        SET(CMAKE_MACOSX_RPATH TRUE) #enable RPATH on OSX. This also suppress warnings on CMake >= 3.0
        # when building, don't use the install RPATH already
        # (but later on when installing)
        SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
        #build directory by default is built with RPATH
        SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

        #This is relative RPATH for libraries built in the same project
        #I assume that the directory is
        # - install_dir/something for binaries
        # - install_dir/lib for libraries
        LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
        IF("${isSystemDir}" STREQUAL "-1")
            FILE(RELATIVE_PATH _rel_path "${CMAKE_INSTALL_PREFIX}/bin" "${CMAKE_INSTALL_PREFIX}/lib")
            IF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
                SET(CMAKE_INSTALL_RPATH "@loader_path/${_rel_path}")
            ELSE()
                SET(CMAKE_INSTALL_RPATH "\$ORIGIN/${_rel_path}")
            ENDIF()
        ENDIF("${isSystemDir}" STREQUAL "-1")
        # add the automatically determined parts of the RPATH
        # which point to directories outside the build tree to the install RPATH
        SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE) #very important!
    ENDIF()
ENDIF()
#####end RPATH

ADD_LIBRARY(orocos-kdl ${LIB_TYPE} ${KDL_SRCS} config.h)

TARGET_INCLUDE_DIRECTORIES(orocos-kdl PUBLIC
  "$<INSTALL_INTERFACE:include>")

SET_TARGET_PROPERTIES( orocos-kdl PROPERTIES
  SOVERSION "${KDL_VERSION_MAJOR}.${KDL_VERSION_MINOR}"
  VERSION "${KDL_VERSION}"
  COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS}"
  PUBLIC_HEADER "${KDL_HPPS};${CMAKE_CURRENT_BINARY_DIR}/config.h"
  )
TARGET_INCLUDE_DIRECTORIES(orocos-kdl PUBLIC ${Eigen3_INCLUDE_DIRS})

#### Settings for rpath disabled (back-compatibility)
IF(${CMAKE_MINIMUM_REQUIRED_VERSION} VERSION_GREATER "2.8.12")
    MESSAGE(AUTHOR_WARNING "CMAKE_MINIMUM_REQUIRED_VERSION is now ${CMAKE_MINIMUM_REQUIRED_VERSION}. This check can be removed.")
ENDIF()
IF(CMAKE_VERSION VERSION_LESS 2.8.12)
    SET_TARGET_PROPERTIES( orocos-kdl PROPERTIES
      INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
ELSE()
    IF(NOT OROCOSKDL_ENABLE_RPATH)
        SET_TARGET_PROPERTIES( orocos-kdl PROPERTIES
          INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
    ENDIF()
ENDIF()
#####end RPATH

# Needed so that the generated config.h can be used
TARGET_INCLUDE_DIRECTORIES(orocos-kdl PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>")
TARGET_LINK_LIBRARIES(orocos-kdl ${Boost_LIBRARIES})

INSTALL(TARGETS orocos-kdl
  EXPORT OrocosKDLTargets
  ARCHIVE DESTINATION lib${LIB_SUFFIX}
  LIBRARY DESTINATION lib${LIB_SUFFIX}
  PUBLIC_HEADER DESTINATION include/kdl
)

INSTALL(FILES ${UTIL_HPPS} DESTINATION include/kdl/utilities)

# Orocos convention:
CONFIGURE_FILE( kdl.pc.in ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdl.pc @ONLY)
CONFIGURE_FILE( kdl.pc.in ${CMAKE_CURRENT_BINARY_DIR}/orocos_kdl.pc @ONLY)

INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdl.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/orocos_kdl.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig)

=== debian/changelog ===
ros-foxy-orocos-kdl (3.3.5-1focal) focal; urgency=high

  * Add changelog
  * Delete manifest.xml (#26 <https://github.com/ros2/orocos_kinematics_dynamics/issues/26>) (#28 <https://github.com/ros2/orocos_kinematics_dynamics/issues/28>)
  * Contributors: giusebar, Dharini Dutia, mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 16 Mar 2023 00:00:00 -0000

ros-foxy-orocos-kdl (3.3.4-1focal) focal; urgency=high

  * Update maintainers to Ivan Paunovic (#25 <https://github.com/ros2/orocos_kinematics_dynamics/issues/25>)
  * Merge pull request #21 <https://github.com/ros2/orocos_kinematics_dynamics/issues/21> from ros2/update_licenses (#22 <https://github.com/ros2/orocos_kinematics_dynamics/issues/22>)
  * Contributors: Audrow Nash, Karsten Knese

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 25 Jul 2022 00:00:00 -0000

ros-foxy-orocos-kdl (3.3.2-1focal) focal; urgency=high

  * Update cmake minimum version to 2.8.12 (#17 <https://github.com/ros2/orocos_kinematics_dynamics/issues/17>)
  * Update maintainer (#16 <https://github.com/ros2/orocos_kinematics_dynamics/issues/16>)
  * Contributors: Jacob Perron, Stephen Brawner

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 25 Jan 2021 00:00:00 -0000

ros-foxy-orocos-kdl (3.3.1-1focal) focal; urgency=high

  * export modern CMake interface target (#14 <https://github.com/ros2/orocos_kinematics_dynamics/issues/14>)
  * Contributors: Dirk Thomas

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 08 May 2020 00:00:00 -0000

ros-foxy-orocos-kdl (3.3.0-1focal) focal; urgency=high

  * Merge pull request #13 <https://github.com/ros2/orocos_kinematics_dynamics/issues/13> from ros2/ivanpauno/sync-with-upstream
  * Merge remote-tracking branch 'upstream/master' into ivanpauno/sync-with-upstrea
  * Merge pull request #221 <https://github.com/ros2/orocos_kinematics_dynamics/issues/221> from sloretz/bump_cmake_cmp0048
  * Use CMP0048 New behavior to suppress warning
  * Merge pull request #215 <https://github.com/ros2/orocos_kinematics_dynamics/issues/215> from ros2/ivanpauno/fix-build-warning-focal
  * Make it work in c++03 too
  * Fix build warnings in gcc 9.2.1
  * Merge pull request #209 <https://github.com/ros2/orocos_kinematics_dynamics/issues/209> from mvieth/master
  * Move SVD algorithm from hpp to cpp file
  * Remove wrong doc comments in ChainIKSolver
  * Remove unused variable in ChainIKSolver
  * Switch order in constructor to match field order
  * Make parameter unsigned
  * Fix/standardize whitespace and indentation
  * Comment out unused parameters to avoid warnings
  * Make loop variables unsigned
  * Remove unnecessary semicolons
  * Merge pull request #196 <https://github.com/ros2/orocos_kinematics_dynamics/issues/196> from francofusco/expose_joint_properties
  * Merge pull request #174 <https://github.com/ros2/orocos_kinematics_dynamics/issues/174> from francofusco/new_tree_features
  * Merge pull request #199 <https://github.com/ros2/orocos_kinematics_dynamics/issues/199> from maverick-long/fix_rotation_angle_numerical_error
  * Use eigen3_cmake_module (#11 <https://github.com/ros2/orocos_kinematics_dynamics/issues/11>)
  * remove comment
  * back to a more numerically stable method to compute the rotation angle
  * Joint: getDamping() & getStiffness()
  * 1.3.2
  * Merge pull request #195 <https://github.com/ros2/orocos_kinematics_dynamics/issues/195> from orocos/cherry-pick-109-1.3
  * fix build for missing isnan definition in newer compilers
  * KDL Frames: Added Improper Rotation test for GetRotAngle
  * KDL frames:  removed unnecessary epsilon checks in GetRotAngle singular case
  * fix: GetRotAngle no longer causes NaNs on slightly non-orthogonal rotation matrices
  * tests: added test for GetRotAngle on slightly non-orthogonal matrices
  * Add edge testcase for GetRotAngle
  * fix(): Orocos tests additions
  * fix(): make arbitrary axis the same as for orocos convention
  * fix(): disable tests in CMakeLists.txt
  * fix(GetRotAngle): New GetRotAngle function to prevent erros of some flipping
  * Merge pull request #173 <https://github.com/ros2/orocos_kinematics_dynamics/issues/173> from francofusco/tree_inv_dyn_solver_rne
  * Removed std::to_string
  * Cast to uint in comparison test
  * Merge pull request #187 <https://github.com/ros2/orocos_kinematics_dynamics/issues/187> from orocos/fix/warnings
  * Merge pull request #171 <https://github.com/ros2/orocos_kinematics_dynamics/issues/171> from craigirobot/upstream-master-chain-forward-dynamics
  * Merge pull request #188 <https://github.com/ros2/orocos_kinematics_dynamics/issues/188> from luzpaz/follow-up-typo-whitespace-fixes
  * Merge pull request #186 <https://github.com/ros2/orocos_kinematics_dynamics/issues/186> from orocos/fix/std-isnan
  * scoped_ptr: add missing newline at end of file
  * Misc. source comment typo and whitespace fixes
  * Merge pull request #184 <https://github.com/ros2/orocos_kinematics_dynamics/issues/184> from luzpaz/misc-typos
  * miscellaneous warning fixes
  * utilities: replace deprecated auto_ptr with a basic smart pointer scoped_ptr (supports C++98)
  * fix build for missing isnan definition in newer compilers
  * fix LDL solver test (copy-paste error)
  * Add LDL solver test
  * Add FD solver tests
  * Implement LDL solver for finding joint acceleration
  * Generate forward dynamics solver for chain based on recursive Newton-Euler Method
  * Misc doxy and source comment typo fixes
  * Edit test
  * Using stringstream
  * Added #include<string>
  * Added #include<stdexcept>
  * Merge pull request #179 <https://github.com/ros2/orocos_kinematics_dynamics/issues/179> from orocos/revert-178-fix/path_circle_memory_leak
  * Revert "Add private constructor for delegating initialization. Fixes #177 <https://github.com/ros2/orocos_kinematics_dynamics/issues/177>."
  * Merge pull request #178 <https://github.com/ros2/orocos_kinematics_dynamics/issues/178> from martiniil/fix/path_circle_memory_leak


=== debian/control ===
Source: ros-foxy-orocos-kdl
Section: misc
Priority: optional
Maintainer: Ivan Paunovic <ivanpauno@ekumenlabs.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libcppunit-dev <!nocheck>, libeigen3-dev, ros-foxy-eigen3-cmake-module, ros-foxy-ros-workspace
Homepage: http://wiki.ros.org/orocos_kdl
Standards-Version: 3.9.2

Package: ros-foxy-orocos-kdl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, pkg-config, ros-foxy-eigen3-cmake-module, ros-foxy-ros-workspace
Description: This package contains a recent version of the Kinematics and Dynamics Library (KDL), distributed by the Orocos Project.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-orocos-kdl//opt/ros/foxy/lib/:$(CURDIR)/debian/ros-foxy-orocos-kdl//opt/ros/foxy/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
